unit CarsMainFormU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CarsClassU, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    RG: TRadioGroup;
    Button3: TButton;
    Button4: TButton;
    edtWant: TEdit;
    lblGot: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure RGClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Robin: TRobin;
    Porsche: TPorsche;
    Garage: array[0..1] of TCar;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Robin := TRobin.Create(45);
  Porsche := TPorsche.Create(30);
  Garage[0] := Robin;
  Garage[1] := Porsche;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Robin.Free;
  Robin := nil;
  Porsche.Free;
  Porsche := nil
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Robin.Drive
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Porsche.Drive
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Garage[RG.ItemIndex].Drive
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Garage[RG.ItemIndex].Speed := StrToInt(edtWant.Text);
  lblGot.Caption := IntToStr(Garage[RG.ItemIndex].Speed);
end;

procedure TForm1.RGClick(Sender: TObject);
begin
  lblGot.Caption := IntToStr(Garage[RG.ItemIndex].Speed);
end;

end.
