unit InterfaceTestImplU;

interface

uses
  InterfaceTestIntfU;

type
  THello = class(TInterfacedObject, IHello)
  public
    constructor Create;
    destructor Destroy; override;
    procedure SayHi;
  end;

  THello2 = class(TInterfacedObject, IHello, IHelloGoodbye)
  public
    constructor Create;
    destructor Destroy; override;
    procedure SayHi;
    procedure SayBye;
  end;

implementation

uses
  Dialogs;

{ THello }

constructor THello.Create;
begin
  inherited;
  ShowMessageFmt('A %s is born', [ClassName])
end;

destructor THello.Destroy;
begin
  ShowMessageFmt('A %s bites the dust', [ClassName]);
  inherited
end;

procedure THello.SayHi;
begin
  ShowMessageFmt('Hi from a %s', [ClassName])
end;

{ THello2 }

constructor THello2.Create;
begin
  inherited;
  ShowMessageFmt('A %s is born', [ClassName])
end;

destructor THello2.Destroy;
begin
  ShowMessageFmt('A %s bites the dust', [ClassName]);
  inherited
end;

procedure THello2.SayBye;
begin
  ShowMessageFmt('Ta-ta from a %s', [ClassName])
end;

procedure THello2.SayHi;
begin
  ShowMessageFmt('Hello from a %s', [ClassName])
end;

end.
